;ͻ
; Script: Chgpicv1.sc     Creation Date: 10/18/95 Author: R. Summerlin  
;                         Last Revision:          CIS:  102054,3330     
;Ķ
; Description: Script to change a previously defined PICTURE in the .DB's 
;              of the current directory to another PICTURE definition. I  
;              am writing this script to assist myself in changing all    
;              of my PICTURE statements from ##/##/## to ##/##/##[##] to  
;              accomadate the entry of the year 2000.                     
;                                                                         
;Ķ
; *****  FOR PARADOX 4.x VERSIONS   ******                                
;Ķ
; Libraries:                                                              
;Ķ
; Tables    Forms    Reports  Scripts   Procedures     External Pgms 
;Ķ
;                                                                    
;                                                                    
;                                                                    
;                                                                    
;Ķ
;Notes: The PICTURE capture ideas came from Elizabeth A. Swoope of LSU's  
;       Department of Experimental Statistics in a utility she wrote to   
;       list all the Validity checks placed on a .DB file. The script is  
;       called ValChk3a.SC, The script has been very helpful to me and I  
;       thank her.                                                        
;                                                                         
;ͼ

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

SHOWPULLDOWN ENDMENU
PROMPT ""
TKECHO NORMAL
TKECHO OFF


;<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>

PROC ClearWorkspace()

IF SYSMODE() <> "Main" THEN
      DO_IT!
ENDIF

KEYPRESS "F38"

WINDOW LIST TO Fred

FOR ThisList FROM 1 TO ARRAYSIZE(Fred)
WINDOW CLOSE
ENDFOR

TKECHO NORMAL
TKECHO OFF

ENDPROC

;<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>

PROC AskPicture(DoWhat)

Pic=""
ButVal=""

SHOWDIALOG "-=****  Picture  ****=-"
    @6,14 HEIGHT 10 WIDTH 50
    
    @1,25-INT((LEN(DoWhat)+25)/2) ?? " Please Enter Picture to "+STRVAL(DoWhat)+" "
    ACCEPT @4,12 WIDTH 26
       "A15"
       TAG "Word"
       TO Pic


      PUSHBUTTON @6,5 WIDTH 10
       "~O~k"
       OK
       DEFAULT
       VALUE "OK"
       TAG "Oktag"
       TO ButVal
       

      PUSHBUTTON @6,32 WIDTH 10
       "~C~ancel"
       CANCEL
       VALUE "CANCEL"
       TAG "Cantag"
       TO ButVal
    

 ENDDIALOG

RETURN Pic

ENDPROC


;<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>

PROC PerCentBar2(Div,Ttl)

Percnt=INT((Div/Ttl)*100)

IF NOT ISASSIGNED(Prct_w) THEN
        DYNARRAY Fred.a[]
          Fred.a["HASSHADOW"]=FALSE
          Fred.a["HASFRAME"]=FALSE
          Fred.a["CANMOVE"]=FALSE
          Fred.a["STYLE"]=16+14
          Fred.a["HEIGHT"]=7
          Fred.a["WIDTH"]=28
          Fred.a["ORIGINCOL"]=26
          Fred.a["ORIGINROW"]=0
          Fred.a["FLOATING"]=TRUE
          
        WINDOW CREATE ATTRIBUTES Fred.a TO Prct_w
        
        STYLE ATTRIBUTE 16+15
        @1,5
        ?? " Percent Complete "
        STYLE ATTRIBUTE Fred.a["STYLE"]
        @3,3
        ?? "0    25   50   75  100"
        @4,3
        ?? "Ĵ"
        
        

        FRAME DOUBLE FROM 0,0 TO Fred.a["Height"]-1,Fred.a["Width"]-1
        @5,3
        ?? ""
        @5,24
        ?? ""
        STYLE ATTRIBUTE 16+15
        @5,4
        ?? ""

ENDIF

WINDOW SELECT Prct_w
Cent=STRVAL(INT((Div/Ttl)*100))+"%"
STYLE ATTRIBUTE 16+10
        @2,13
        ?? Cent
STYLE ATTRIBUTE 16+15
SWITCH
   CASE Percnt>=5 AND Percnt<=9 :
         @5,4
         ?? "۰"
   CASE Percnt>=10 AND Percnt<=14 :
         @5,4
         ?? "۰"
   CASE Percnt>=15 AND Percnt<=19 :
         @5,4
         ?? "۰"
   CASE Percnt>=20 AND Percnt<=24 :
         @5,4
         ?? "۰"
   CASE Percnt>=25 AND Percnt<=29 :
         @5,4
         ?? "۰"
   CASE Percnt>=30 AND Percnt<=34 :
         @5,4
         ?? "۰"
   CASE Percnt>=35 AND Percnt<=39 :
         @5,4
         ?? "۰"
   CASE Percnt>=40 AND Percnt<=44 :
         @5,4
         ?? "۰"
   CASE Percnt>=45 AND Percnt<=49 :
         @5,4
         ?? "۰"
   CASE Percnt>=50 AND Percnt<=54 :
         @5,4
         ?? "۰"
   CASE Percnt>=55 AND Percnt<=59 :
         @5,4
         ?? "۰"
   CASE Percnt>=60 AND Percnt<=64 :
         @5,4
         ?? "۰"
   CASE Percnt>=65 AND Percnt<=69 :
         @5,4
         ?? "۰"
   CASE Percnt>=70 AND Percnt<=74 :
         @5,4
         ?? "۰"
   CASE Percnt>=75 AND Percnt<=79 :
         @5,4
         ?? "۰"
   CASE Percnt>=80 AND Percnt<=84 :
         @5,4
         ?? "۰"
   CASE Percnt>=85 AND Percnt<=89 :
         @5,4
         ?? "۰"
   CASE Percnt>=90 AND Percnt<=94 :
         @5,4
         ?? "۰"
   CASE Percnt>=95 AND Percnt<=99 :
         @5,4
         ?? "۰"
   CASE Percnt=100 :
         @5,4
         ?? ""
         SLEEP 1000
         RELEASE VARS Prct_w, Ttl, Percnt, Div
         WINDOW CLOSE
ENDSWITCH

ENDPROC


;<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>


PROC NewInfo()

;<<<<<<<<  How Big Should Box Be and Where to Center Msg's   >>>>>>>>>
SWITCH
   CASE ISASSIGNED(Msg1) AND ISASSIGNED(Msg2) AND ISASSIGNED(Msg3) AND ISASSIGNED(Msg4) :
        Wdth=MAX(LEN(Msg1),LEN(Msg2))
        Wdth=MAX(Wdth,LEN(Msg3))
        Wdth=MAX(Wdth,LEN(Msg4))
        Wdth=Wdth+8
        Hgt=8
        M1=INT((Wdth/2)-(LEN(Msg1)/2))
        M2=INT((Wdth/2)-(LEN(Msg2)/2))         
        M3=INT((Wdth/2)-(LEN(Msg3)/2))         
        M4=INT((Wdth/2)-(LEN(Msg4)/2))         
   CASE ISASSIGNED(Msg1) AND ISASSIGNED(Msg2) AND ISASSIGNED(Msg3) :
        Wdth=MAX(LEN(Msg1),LEN(Msg2))
        Wdth=MAX(Wdth,LEN(Msg3))
        Wdth=Wdth+8
        Hgt=7
        M1=INT((Wdth/2)-(LEN(Msg1)/2))
        M2=INT((Wdth/2)-(LEN(Msg2)/2))         
        M3=INT((Wdth/2)-(LEN(Msg3)/2))
   CASE ISASSIGNED(Msg1) AND ISASSIGNED(Msg2) :
        Wdth=MAX(LEN(Msg1),LEN(Msg2))+8
        Hgt=6
        M1=INT((Wdth/2)-(LEN(Msg1)/2))
        M2=INT((Wdth/2)-(LEN(Msg2)/2))         
   CASE ISASSIGNED(Msg1) :
        Wdth=LEN(Msg1)+8
        Hgt=5
        M1=INT((Wdth/2)-(LEN(Msg1)/2))
ENDSWITCH

SWITCH
   CASE B=96 :
        Sb=0
        Sb1=15
   CASE B=0 :
        Sb=8
        Sb1=15
   OTHERWISE :
        Sb=0
        Sb1=INT((B/15)+8)
ENDSWITCH

DYNARRAY Show[]
   Show["Hasframe"]=FALSE
   Show["Hasshadow"]=TRUE
   Show["Canmove"]=FALSE
   Show["Canclose"]=FALSE
   Show["Canmaximize"]=FALSE
   Show["Canresize"]=FALSE
   Show["Canvas"]=TRUE
   Show["Echo"]=TRUE
   Show["Floating"]=TRUE
   Show["Height"]=Hgt
   Show["Origincol"]=INT(INT(78/2)-INT(Wdth/2))
   Show["Originrow"]=INT(INT(22/2)-INT(Hgt/2))
   Show["Style"]=NUMVAL(S)
   Show["Width"]=Wdth
   
   WINDOW CREATE TO FRED
   WINDOW SELECT FRED
   WINDOW HANDLE CURRENT TO MERV
   WINDOW SETATTRIBUTES MERV FROM Show
   PAINTCANVAS ATTRIBUTE Show["Style"] ALL
   FRAME DOUBLE FROM 0,0 TO Show["Height"]-1,Show["Width"]-1
   PAINTCANVAS ATTRIBUTE NUMVAL(B+Sb) 0,0,Show["Height"]-1,Show["Width"]-1
   PAINTCANVAS ATTRIBUTE NUMVAL(B+Sb1) 0,0,0,Show["Width"]-2
   PAINTCANVAS ATTRIBUTE NUMVAL(B+Sb1) 0,0,Show["Height"],0
   
   FRAME DOUBLE FROM 1,2 TO Show["Height"]-2,Show["Width"]-3
   PAINTCANVAS ATTRIBUTE NUMVAL(B+Sb1) 1,1,Show["Height"]-2,Show["Width"]-2
   PAINTCANVAS ATTRIBUTE NUMVAL(B+Sb) 1,1,1,Show["Width"]-4
   PAINTCANVAS ATTRIBUTE NUMVAL(B+Sb) 1,1,Show["Height"],2
   
SWITCH
   CASE ISASSIGNED(M1) AND ISASSIGNED(M2) AND ISASSIGNED(M3) AND ISASSIGNED(M4) :
        IF ISASSIGNED(B1) THEN
             STYLE ATTRIBUTE Show["Style"]+B1
             SETMARGIN M1
             @1,NUMVAL(M1)
             ? STRVAL(Msg1)
             STYLE ATTRIBUTE Show["Style"]
           ELSE SETMARGIN M1
                @1,NUMVAL(M1)
                ? STRVAL(Msg1)
        ENDIF
        IF ISASSIGNED(B2) THEN
             STYLE ATTRIBUTE Show["Style"]+B2
             SETMARGIN M2
             @2,NUMVAL(M2)
             ? STRVAL(Msg2)
             STYLE ATTRIBUTE Show["Style"]
           ELSE SETMARGIN M2
                @2,NUMVAL(M2)
                ? STRVAL(Msg2)
        ENDIF
        IF ISASSIGNED(B3) THEN
             STYLE ATTRIBUTE Show["Style"]+B3
             SETMARGIN M3
             @3,NUMVAL(M3)
             ? STRVAL(Msg3)
             STYLE ATTRIBUTE Show["Style"]
           ELSE SETMARGIN M3
                @3,NUMVAL(M3)
                ? STRVAL(Msg3)
        ENDIF
        IF ISASSIGNED(B4) THEN
             STYLE ATTRIBUTE Show["Style"]+B4
             SETMARGIN M4
             @4,NUMVAL(M4)
             ? STRVAL(Msg4)
             STYLE ATTRIBUTE Show["Style"]
           ELSE SETMARGIN M4
                @4,NUMVAL(M4)
                ? STRVAL(Msg4)
        ENDIF                
   CASE ISASSIGNED(M1) AND ISASSIGNED(M2) AND ISASSIGNED(M3) :
        IF ISASSIGNED(B1) THEN
             STYLE ATTRIBUTE Show["Style"]+B1
             SETMARGIN M1
             @1,NUMVAL(M1)
             ? STRVAL(Msg1)
             STYLE ATTRIBUTE Show["Style"]
           ELSE SETMARGIN M1
                @1,NUMVAL(M1)
                ? STRVAL(Msg1)
        ENDIF
        IF ISASSIGNED(B2) THEN
             STYLE ATTRIBUTE Show["Style"]+B2
             SETMARGIN M2
             @2,NUMVAL(M2)
             ? STRVAL(Msg2)
             STYLE ATTRIBUTE Show["Style"]
           ELSE SETMARGIN M2
                @2,NUMVAL(M2)
                ? STRVAL(Msg2)
        ENDIF
        IF ISASSIGNED(B3) THEN
             STYLE ATTRIBUTE Show["Style"]+B3
             SETMARGIN M3
             @3,NUMVAL(M3)
             ? STRVAL(Msg3)
             STYLE ATTRIBUTE Show["Style"]
           ELSE SETMARGIN M3
                @3,NUMVAL(M3)
                ? STRVAL(Msg3)
        ENDIF
   CASE ISASSIGNED(M1) AND ISASSIGNED(M2) :
        IF ISASSIGNED(B1) THEN
             STYLE ATTRIBUTE Show["Style"]+B1
             SETMARGIN M1
             @1,NUMVAL(M1)
             ? STRVAL(Msg1)
             STYLE ATTRIBUTE Show["Style"]
           ELSE SETMARGIN M1
                @1,NUMVAL(M1)
                ? STRVAL(Msg1)
        ENDIF
        IF ISASSIGNED(B2) THEN
             STYLE ATTRIBUTE Show["Style"]+B2
             SETMARGIN M2
             @2,NUMVAL(M2)
             ? STRVAL(Msg2)
             STYLE ATTRIBUTE Show["Style"]
           ELSE SETMARGIN M2
                @2,NUMVAL(M2)
                ? STRVAL(Msg2)
        ENDIF   
   CASE ISASSIGNED(M1) :
        IF ISASSIGNED(B1) THEN
             STYLE ATTRIBUTE Show["Style"]+B1
             SETMARGIN M1
             @1,NUMVAL(M1)
             ? STRVAL(Msg1)
             STYLE ATTRIBUTE Show["Style"]
           ELSE SETMARGIN M1
                @1,NUMVAL(M1)
                ? STRVAL(Msg1)
        ENDIF
ENDSWITCH

RELEASE VARS Msg1, Msg2, Msg3, Msg4, Wdth, Hgt, M1, M2, M3, M4, B1, B2, B3, B4, Show, S, B

ENDPROC


;<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>

PROC PickTables()


KEYPRESS "F38"
TKECHO NORMAL
TKECHO OFF

Msg1 = "Compiling File List ..."
S = 16+15
B = 16
B1 = 128
NewInfo()


{Tools} {Info} {Inventory} {Tables} {} ClearImage {Modify} 
{Restructure} {list} Down Del Do_It! {Delete} ClearImage {Modify} 
{Restructure} {list} Down  "Rpt" Enter  "a1" Do_It! EditKey 

PROMPT
WINDOW CLOSE

WAIT TABLE
    PROMPT "'Y' (or any character) in RPT Field to mark File, [F2] to Start ... "
UNTIL "F2"

DO_IT!
ClearWorkspace()


ENDPROC

;<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>
; Proc from Elizabeth Swoope script Valchk3a.sc


PROC ValCheck(vchektyp)                               
                                  ; PROC to "trap" validity check value
    SELECT vchektyp               ; vchektyp is the type of validity check
    vchekval = MENUCHOICE()       ; vchekval is the value stored in the 
                                  ; validity check
    Esc
    RETURN vchekval

ENDPROC


;<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>

PROC ChgValCheck(vchektyp, RepWith)                               
                                  ; Proc to change the validity check
    SELECT vchektyp               ; if it matches the search criteria.
    SELECT RepWith

ENDPROC


;<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>
PROC CLOSED CheckForLocks(Oper,   ;Operation that will be performed.
                          File1,  ;File operation needs locks checked for.
                          File2)  ;Optional. If Operation uses 2 Files.

   USEVARS AutoLib, ErrorProc
   PRIVATE Oper, File1, File2, Well, Fred, DoneVal, EatChar


Well=0

WHILE Well=0

SWITCH
   CASE UPPER(Oper) = "VIEW" :
       LOCK File1 PFL
   CASE UPPER(Oper) = "ASK" :
       LOCK File1 PFL
   CASE UPPER(Oper) = "EDIT" :
       LOCK File1 FL
   CASE UPPER(Oper) = "COEDIT" :
       LOCK File1 PFL
   CASE UPPER(Oper) = "SORT" :      ;Only for a sort to same table as of now
       LOCK File1 FL
   CASE UPPER(Oper) = "RENAME" :
       LOCK File1 FL
   CASE UPPER(Oper) = "COPY" :
       LOCK File1 WL
       LOCK File2 FL
   CASE UPPER(Oper) = "ADD" :
       LOCK File1 WL
       LOCK File2 PWL
   CASE UPPER(Oper) = "SUBTRACT" :
       LOCK File1 FL
       LOCK File2 FL
   CASE UPPER(Oper) = "EMPTY" :
       LOCK File1 FL
ENDSWITCH




IF Retval THEN  
       Well=1         ;If successful, Return
       DoneVal = True
        IF ISASSIGNED(Fred) THEN
              WINDOW CLOSE        ;Close Info Window
        ENDIF
   ELSE IF ISASSIGNED(Fred) THEN
           ELSE Msg1=" Needed Resource is Busy! "
                Msg2=" Resource is held by: "+ERRORUSER()
                Msg3=" Will retry until resource is released. "
                Msg4=" Press any key to End Wait ... "
                S=64+14
                B=64
                B4=128
                NewInfo()
                
                WINDOW HANDLE CURRENT TO Fred     ;Record Handle for Check
        ENDIF
        
        IF CHARWAITING() THEN
              Well = 1
              EatChar = GETCHAR()
              DoneVal = False     ;Return False Value
              WINDOW CLOSE
              RETURN DoneVal
        ENDIF
ENDIF

ENDWHILE

;<<<<<<<<<<<<<<<<<<  Unlock file Locks   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>

SWITCH
   CASE UPPER(Oper) = "VIEW" :
       UNLOCK File1 PFL
   CASE UPPER(Oper) = "ASK" :
       UNLOCK File1 PFL
   CASE UPPER(Oper) = "EDIT" :
       UNLOCK File1 FL
   CASE UPPER(Oper) = "COEDIT" :
       UNLOCK File1 PFL
   CASE UPPER(Oper) = "SORT" :      ;Only for a sort to same table as of now
       UNLOCK File1 FL
   CASE UPPER(Oper) = "RENAME" :
       UNLOCK File1 FL
   CASE UPPER(Oper) = "COPY" :
       UNLOCK File1 WL
       UNLOCK File2 FL
   CASE UPPER(Oper) = "ADD" :
       UNLOCK File1 WL
       UNLOCK File2 PWL
   CASE UPPER(Oper) = "SUBTRACT" :
       UNLOCK File1 FL
       UNLOCK File2 FL
   CASE UPPER(Oper) = "EMPTY" :
       UNLOCK File1 FL
ENDSWITCH


RETURN DoneVal



ENDPROC


;<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>

PROC CLOSED Main()         ;Main program execution proc.
   USEVARS AutoLib, ErrorProc


Rep = AskPicture("Replace")

IF Rep = "" THEN
    RETURN
ENDIF


RepWith = AskPicture("Replace With")

IF RepWith = "" THEN
     RETURN
ENDIF

PickTables()        ;Chose tables to change picture

ClearWorkspace()


Msg1 = " Changing picture "+STRVAL(Rep)+" to "
Msg2 = " picture "+STRVAL(RepWith)+" in all the marked"
Msg3 = " Files."
S = 16+14
B = 16
NewInfo()


Times = NRECORDS("LIST")

                  ;<<<<<<<<<<<<  Table Loop    >>>>>>>>>>
FOR Ab FROM 1 TO Times

VIEW "LIST"
MOVETO RECORD Ab

PerCentBar2(Ab, Times)      ;PerCent Display

IF ISBLANK([Rpt]) THEN         ;If not marked
     LOOP
ENDIF

Tbl = [Name]
KEYPRESS "F38"

IF ISTABLE(Tbl) THEN         ;Is the table valid - It should be from the list
   ELSE LOOP                 ;but you never know.
ENDIF

                  ;<<<<<<<<<<<<<  Field Loop   >>>>>>>>>>>>
NFlds = NFIELDS(Tbl)

IF CheckForLocks("Edit", Tbl, "") THEN     ;Make sure I can Edit this Table
   ELSE LOOP
ENDIF


EDIT Tbl

WHILE FIELD() <> "#"        ;Get to # field
Left
ENDWHILE


FOR Yz FROM 1 TO NFlds

ENTER              ;Move to next field


Menu {Valcheck} {Define} Enter

ValEntry =  VALCHECK("Picture")       ;Get what is entered in

IF ValEntry = Rep THEN                ;If entry in Picture matches search
     ChgValCheck("Picture", RepWith)  ;Value. Replace it with Replace value.
   ELSE Esc
        Esc
        Esc              ;Get back to Field
        Esc
ENDIF

ENDFOR
          ;<<<<<<<<<<<<<<<  End of Field Loop   >>>>>>>>>>>>>

DO_IT!
KEYPRESS "F38"

ENDFOR
          ;<<<<<<<<<<<<<<<<   End Table Loop    >>>>>>>>>>>>>>>


CleanUp()

ENDPROC


;<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>
PROC CleanUp()

ClearWorkspace()

Msg1 = "Cleaning up ..."
S = 64+15
B = 64
B1 = 128
NewInfo()

IF ISTABLE("List") THEN
     DELETE "LIST"
ENDIF

IF ISTABLE("Struct") THEN
     DELETE "STRUCT"
ENDIF

RELEASE VARS Rep, RepWith, Ab, Yz, Times, NFlds

ClearWorkspace()

RELEASE PROCS ALL

ENDPROC


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;    End of Procs
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;<<<<<<<<<<<<<<<>>>>>>>>>>>
; Start Program

Main()